# What is JWT ?

JWT stands for JSON Web Token. It's an open standard (RFC 7519) that defines a compact and self-contained way for securely transmitting information between parties as a JSON object. This information can be verified and trusted because it is digitally signed. JWTs are often used for authentication and information exchange in web development.

Here's a detailed breakdown of JWT:

1. **JSON Format :**
   - JWTs are represented as JSON objects. For example:
     ```
     {
       "sub": "1234567890",
       "name": "John Doe",
       "iat": 1516239022
     }
     ```
   - This JSON object is called a JWT Claims Set, and it contains information about a subject ("sub"), their name ("name"), and an issued at time ("iat").

2. **Compactness :**
   - JWTs are designed to be compact, making them easy to transmit over networks or include in URLs. This is crucial for scenarios where tokens are passed around frequently, like in authentication systems.

3. **Self-contained :**
   - A JWT contains all the information it needs to convey its meaning. It's not necessary to query a database or any external service to interpret the token. This makes JWTs highly efficient.

4. **Parts of a JWT :**
   - JWTs consist of three parts separated by dots (`.`): Header, Payload, and Signature.
     - **Header :** Contains metadata about the type of token and the signing algorithm used. It's usually Base64Url encoded. Example:
       ```
       {
         "alg": "HS256",
         "typ": "JWT"
       }
       ```
     - **Payload :** Contains the claims (statements) about an entity (typically a user) and additional data. It's also Base64Url encoded. Example:
       ```
       {
         "sub": "1234567890",
         "name": "John Doe",
         "iat": 1516239022
       }
       ```
     - **Signature :** Used to verify the authenticity of the token. It's created by taking the encoded header, encoded payload, a secret, and a signing algorithm, then hashing them.

5. **Signing :**
   - JWTs can be signed using various algorithms like HMAC SHA256 or RSA. This ensures that the sender is who they say they are and that the message wasn't tampered with.

6. **Verification :**
   - When a server receives a JWT, it can verify the signature using the secret key (if using symmetric signing) or the public key (if using asymmetric signing). This ensures that the token is genuine.

7. **Use Cases :**
   - **Authentication :** JWTs are commonly used for user authentication. After a user logs in, a JWT is generated and sent to the client. The client includes this token in the headers of subsequent requests, allowing the server to identify the user.

8. **Expiration and Issued At Time :**
   - JWTs can have expiration times and an "issued at" time. This helps in controlling the lifespan of the token and preventing the use of old or expired tokens.

9. **Security Considerations :**
   - It's crucial to protect the secret key used for signing JWTs. Leaking the secret could allow an attacker to generate their own valid tokens.

<br>

# Signature in JWT

In a JSON Web Token (JWT), the signature is a cryptographic hash that is generated using a secret key and applied to the encoded header and payload of the JWT. The signature serves as a means of ensuring the integrity and authenticity of the information contained within the token.

Here's a breakdown of the components of a JWT and the role of the signature:

1. **JWT Structure :**
   A JWT is composed of three parts, each encoded in base64url format and separated by dots (`.`):

   - **Header :** Contains information about how the JWT is encoded and the type of the token (e.g., "JWT").
   - **Payload :** Contains claims, which are statements about an entity (typically the user) and additional data.
   - **Signature :** Generated by applying a cryptographic algorithm to the encoded header and payload, along with a secret key.

   The structure looks like this: `xxxxx.yyyyy.zzzzz`.

2. **Generating the Signature :**
   To create the signature, the header and payload are concatenated with a period (`.`) in between. This concatenated string is then hashed using a cryptographic algorithm (e.g., HMAC-SHA256 or RSA) along with a secret key. The resulting hash is also base64url-encoded, and this value becomes the signature.

   The formula for generating the signature might look like this:
   ```
   signature = base64urlencode(HMACSHA256(base64urlencode(header) + "." + base64urlencode(payload), secret))
   ```

3. **Verification :**
   When a recipient receives a JWT, it can verify the integrity of the token by performing the following steps:

   - Retrieve the header and payload from the JWT.
   - Concatenate the header and payload with a period (`.`) in between.
   - Apply the same cryptographic algorithm used to create the signature along with the known secret key to the concatenated string.
   - Compare the resulting hash with the signature provided in the JWT.

   If the calculated signature matches the signature in the JWT, it indicates that the JWT has not been tampered with and can be trusted.

4. **Purpose :**
   The signature in a JWT serves as a security measure to prevent tampering and forgery. It ensures that the information in the header and payload has not been altered during transmission and that the JWT was indeed generated by a trusted party with access to the secret key.

<br>

# Why we use signature in JWT

The use of a signature in a JSON Web Token (JWT) serves several important purposes, all of which contribute to the security and integrity of the information contained within the token:

1. **Integrity :**
   The signature in a JWT is generated by applying a cryptographic algorithm (e.g., HMAC or RSA) to the token's header and payload, along with a secret key. This process results in a unique signature that is specific to the token's content. By including this signature in the token, any tampering with the header or payload would result in a mismatch when verifying the signature. Therefore, the signature ensures the integrity of the data within the JWT.

2. **Authentication :**
   JWTs are often used for authentication purposes. When a user logs in and receives a JWT, the server can trust the information within the token if the signature is valid. The server, using the same secret key and algorithm, can verify that the JWT has not been forged or tampered with, providing confidence in the identity of the user associated with the token.

3. **Preventing Tampering :**
   Without a signature, a malicious actor could alter the content of a JWT. For example, they might change the user ID, expiration time, or other claims. By including a signature, any attempt to modify the token's payload would invalidate the signature, making it evident that the JWT has been tampered with.

4. **Authorization :**
   JWTs often contain information about the user's roles, permissions, or other claims related to authorization. When a service receives a JWT, it can trust the embedded claims if the signature is valid. This allows for secure and efficient authorization checks based on the information carried in the token.

5. **Secure Information Exchange :**
   JWTs are commonly used for transmitting information securely between parties. The signature ensures that the information sent in the token has not been altered during transit. This is especially important in distributed systems where data may be exchanged between different components or services.
